#define F_CPU 8000000UL

#include "main.h"     // Device specific declarations
#include "ff.h"
#include "lcd.h"

FATFS FatFs;            // FatFs work area needed for each volume
FIL Fil;                        // File object needed for each open file
char Buffer[512]={};//   

void port_ini(void)
{
 	PORTD=0x00;
 	DDRD=0xFF;
 	PORTB=0xFF;
 	DDRB=0xFF;
}

int main(void) {
        UINT bw;
		FRESULT res;
		
		port_ini();
		LCD_ini();  // 
		clearlcd();// 

        // Give a work area to the default drive
        res = f_mount(&FatFs, "", 0);

		setpos(0,0);
		if(res==FR_OK) str_lcd("Done");
  		else str_lcd("Error");
    	//_delay_ms(1000);

		res = f_open(&Fil, "1.txt", FA_READ);
		
		str_lcd("Open file... ");		
		setpos(0,1);  		
		if(res==FR_OK) str_lcd("Done");
  		else str_lcd("Error");
    	//_delay_ms(1000);

        if (res == FR_OK) {
                // Create a file

                // Write data to the file
            res = f_read(&Fil, Buffer, 512, &bw);
		    setpos(0,2);
    		str_lcd("Read file... ");

		    if(res==FR_OK) str_lcd("Done");
		    else sendcharlcd(res+0x30);
				
                // Close the file
                f_close(&Fil);
        }

        // Replace with your application code
    while (1) {
    }
}

